//
// Created by QP on 2025/4/12.
//

#ifndef PCL_WRAPPER_KDTREE_HPP
#define PCL_WRAPPER_KDTREE_HPP

// kdtree.hpp
#pragma once
#include <pcl/kdtree/kdtree_flann.h>
#include "point_types.hpp"

namespace pcl_wrapper {

    template<typename PointT>
    class KdTree {
    public:
        virtual ~KdTree() = default;
        virtual void setInputCloud(typename pcl::PointCloud<PointT>::Ptr cloud) = 0;
        virtual std::vector<int> radiusSearch(const PointT& pt, float radius) = 0;
    };

    template<typename PointT>
    class KdTreeFLANNWrapperImpl : public KdTree<PointT> {
    public:
        void setInputCloud(typename pcl::PointCloud<PointT>::Ptr cloud);

        std::vector<int> radiusSearch(const PointT& pt, float radius);

    private:
        pcl::KdTreeFLANN<PointT> kdtree;
        typename pcl::PointCloud<PointT>::Ptr inputCloud;
    };
}


#endif //PCL_WRAPPER_KDTREE_HPP
