// pcl_wrapper/src/filter.cpp
#include "filter.hpp"
#include <pcl/filters/voxel_grid.h>

namespace pcl_wrapper {

template<typename PointT>
void VoxelGridFilterImpl<PointT>::setLeafSize(float ls) {
    leafSize = ls;
}

template<typename PointT>
void VoxelGridFilterImpl<PointT>::setInputCloud(typename pcl::PointCloud<PointT>::Ptr cloud) {
    inputCloud = cloud;
}

template<typename PointT>
typename pcl::PointCloud<PointT>::Ptr VoxelGridFilterImpl<PointT>::getFilteredCloud() {
    pcl::VoxelGrid<PointT> voxel;
    voxel.setInputCloud(inputCloud);
    voxel.setLeafSize(leafSize, leafSize, leafSize);
    typename pcl::PointCloud<PointT>::Ptr filtered(new pcl::PointCloud<PointT>());
    voxel.filter(*filtered);
    return filtered;
}

// 显式实例化
template class VoxelGridFilterImpl<pcl::PointXYZ>;
template class VoxelGridFilterImpl<pcl::PointXYZI>;


} // namespace pcl_wrapper