
// pcl_wrapper/src/kdtree.cpp
#include "kdtree.hpp"

namespace pcl_wrapper {

template<typename PointT>
void KdTreeFLANNWrapperImpl<PointT>::setInputCloud(typename pcl::PointCloud<PointT>::Ptr cloud) {
    inputCloud = cloud;
    kdtree.setInputCloud(cloud);
}
template<typename PointT>
std::vector<int> KdTreeFLANNWrapperImpl<PointT>::radiusSearch(const PointT& pt, float radius) {
    std::vector<int> indices;
    std::vector<float> sqrDistances;
    kdtree.radiusSearch(pt, radius, indices, sqrDistances);
    return indices;
}

// 显式模板实例化
template class KdTreeFLANNWrapperImpl<pcl::PointXYZ>;
template class KdTreeFLANNWrapperImpl<pcl::PointXYZI>;

 // namespace pcl_wrapper
